/*
  Blank Simple Project.c
  http://learn.parallax.com/propeller-c-tutorials 
*/
#include "simpletools.h"                      // Include simple tools


int cmd;

 unsigned char data;
int rd_pin = 6;
int cs_pin = 15;
int wr_pin = 5;
int rs_pin = 4;
int rest_pin = 16;
int disp_pin = 19;
volatile int control_endpin = 6;
volatile int control_startpin = 4;
volatile int data_startpin = 7;
volatile int data_endpin = 14;

void lcd_rd_high();
void lcd_rd_low();
void lcd_rs_high();
void lcd_rs_low();
void lcd_disp_on();
void lcd_disp_off();
void lcd_cs_high();
void lcd_cs_low();
void lcd_reset_high();
void lcd_reset_low();
void lcd_wr_high();
void lcd_wr_low();
void write_command();
void write_data();
void lcd_write_bus();
void setup();
void disp();
void setwindow(unsigned int s_x, unsigned int e_x,
                unsigned int s_y ,unsigned int e_y);
void engage();
void backlight();
void vert();
void horiz();
void lcd_clock();
void orientation();
void pixel();
void size();
void pin_setup();

int main()                                    // Main function
{
  pin_setup();

 
  while(1)
  {
    // Add main loop code here.
    
  }  
}

void initiate_screen()

{
  pin_setup();
  
  
}  

void pin_setup()


{
  set_outputs(control_endpin,control_startpin,0b00000000);
  set_directions(control_endpin,control_startpin,0b11111111);
  set_outputs(data_endpin,data_startpin,0b00000000);
  set_directions(data_endpin,data_startpin,0b11111111);
 	set_output(rest_pin,0b1);
  set_output(cs_pin,0b1);
  set_output(disp_pin,0b1);
  set_direction(rest_pin,0b1);
  set_direction(cs_pin,0b1);
  set_direction(disp_pin,0b1);
}  

void write_bus( data)

{
  
  set_outputs(data_endpin,data_startpin,data);
  
  
}  



void lcd_rd_high()
 {
   high(rd_pin);
 }
 
void lcd_rd_low()
   {
   low(rd_pin);
   }   



      
void lcd_disp_on()
 {
   high(disp_pin);
 }
 
void lcd_pin_off()
   {
   low(disp_pin);
 } 
 
 
void lcd_rs_high()

  {
   high(rs_pin);
 }
  
void lcd_rs_low()

  {
   low(rs_pin);
 }
 
void lcd_cs_high()

   {
     high(cs_pin);
}  
 
 
void lcd_cs_low()

   {
     low(cs_pin);
}  

 
void lcd_reset_high()

  {
    high(rest_pin);
    
 }
 
void lcd_reset_low()

  {
    low(rest_pin);
    
 }
 
void lcd_wr_high()

  {
    high(wr_pin);
    
  }    
  
  
void lcd_wr_low()

  {
    low(wr_pin);
    
  }   
 
void write_command(data) 

   {
     lcd_rs_low();
        set_outputs(data_endpin,data_startpin,data);
        print("data = %x\n",data);
    // lcd_write_bus(data);
     
     lcd_wr_low();
     lcd_wr_high();

 } 
 
void write_data(data)

    

{
     //lcd_rs_high();//why was this turned off by lavine?
        set_outputs(data_endpin,data_startpin,data);
        print("data = %x\n",data);
    // lcd_write_bus(data);
     
     lcd_wr_low();
     lcd_wr_high();


 } 
 
 
 
void setwindow(unsigned int s_x,unsigned int e_x,
                unsigned int s_y,unsigned int e_y) 

 
/* void setwindow(unsigned int s_x,unsigned int e_x,
                unsigned int s_y,unsigned int e_y)   */
           
           {     
                write_command(0x2a);
                high(rs_pin);
                
                write_data((s_x)>>8);			//SET start column address
	              write_data(s_x);
              // print("data = %s\n",data);
	              write_data((e_x)>>8);			//SET end column address
	              write_data(e_x);

                
                write_command(0x2b);
                high(rs_pin);
                write_data((s_y)>>8);			//SET start page address
	              write_data(s_y);
	              write_data((e_y)>>8);			//SET end page address
	              write_data(e_y);
                write_command(0x2c);
          }
          
          
void size()

{
  
  write_command(0xb0);//set lcd mode set tft 18bits mode
  //lcd_rs_high();
  
  write_data(0x08);//set tft mode hsync and vsync
  write_data(0x80);
  
  write_data(0x03);//set horizonal size high byte
  write_data(0x1f);//set horiz low byte
  write_data(0x01);//set vert high byte
  write_data(0xdf);//set vert low byte
  write_data(0x00);//set even/odd line rgb
  
  
  
  
}

void pixel()

{
  
  write_command(0xf0);//commandwrite sequence******
 // lcd_rs_high();//commandwrite sequence
  write_data(0x00);//commandwrite sequence
  
  
  
}  


void orientation()

{
  write_command(0x36);//commandwrite sequence******
 // lcd_rs_high();//commandwrite sequence
  write_data(0x09);//commandwrite sequence
  
  
  
}   

void lcd_clock()

{
  
  write_command(0xe6);// set pclk freq
  //lcd_rs_high();
  write_data(0x00);
  write_data(0xe7);
  write_data(0x4f);
  
}  

void horiz()

{
  write_command(0xb4);//set horiz backporch
  lcd_rs_high();
  
  write_data(0x04);//set hsync =440
  write_data(0x20);
  write_data(0x00);// set hbp 68
  write_data(0x58);
  write_data(0x80);//set hsync pulse width=128=127pix+1
  write_data(0x00);//set hsync puse start position
  write_data(0x00);
  write_data(0x00);
  
  
  
}  

void vert()

{
  
  write_command(0xb6);// set b=vbp
  lcd_rs_high();
  
  write_data(0x01);//set vsync total
  write_data(0x08);
  write_data(0x00);// set vbp = 19
  write_data(0x13);
  write_data(0x07);//set vsync pulse wideth = 8=7 lines+1
  write_data(0x00);//set vsync pulse start position
  write_data(0x00);
  
  
  
}  

void backlight()

{
  write_command(0xba);
  write_data(0x05);
  
  write_command(0xb8);
  write_data(0x38);
  write_data(0x29);
}  

void engage()

{
  write_command(0x13);
  write_command(0x38);
  write_command(0x29);
  
}  

void display_start()

{
  lcd_rd_high();
  lcd_wr_low();
  lcd_reset_low();
  pause(120);
  
  lcd_reset_high();
  pause(120);
  
  
}              